Index: loader/source/update-custom.c
===================================================================
--- loader/source/update-custom.c	(nonexistent)
+++ loader/source/update-custom.c	(working copy)
@@ -0,0 +1,1105 @@
+/*
+
+Nintendont (Loader) - Playing Gamecubes in Wii mode on a Wii U
+
+Copyright (C) 2014  JoostinOnline
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation version 2.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+
+#include <gccore.h>
+#include "font.h"
+#include "exi.h"
+#include "global.h"
+#include "FPad.h"
+#include "Config.h"
+#include "update.h"
+#include "titles.h"
+#include "dip.h"
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <ogc/stm.h>
+#include <ogc/video.h>
+#include <ogc/video_types.h>
+#include <ogc/consol.h>
+#include <ogc/system.h>
+//#include <fat.h>
+#include <di/di.h>
+#include "menu.h"
+
+#include "ff_utf8.h"
+#include "ssl.h"
+#include "http.h"
+#include <network.h>
+
+extern char launch_dir[MAXPATHLEN];
+extern int selected;
+extern GRRLIB_texImg *preview;
+int menumod = 0;
+char GETID3[8];
+char filenamez[30];
+char urlz[96];
+u32 miss=0;
+char missing[3];
+u32 redraw = 1;
+int empty = 0;
+int del = 0;
+int retry =0;
+
+typedef struct {
+	const char url[96];
+	const char text[36];
+	const char filenamez[30];
+	const u32 max_size;
+} downloads_t;
+
+typedef enum {
+	DOWNLOAD_CUSTOM,
+} DOWNLOADS;
+
+typedef enum {
+	DOWNLOAD_01,
+	DOWNLOAD_02,
+	DOWNLOAD_03,
+	DOWNLOAD_04,
+	DOWNLOAD_05,
+	DOWNLOAD_06,	
+	DOWNLOAD_07
+} DOWNLOADZ;
+ 
+static const downloads_t Downloads[] = {
+	{"http://nintendont.gxarena.com/themes/test.png", "Downloading Custom Game Theme", "test.png", 0x400000}, // 4MB
+};
+
+extern NIN_CFG* ncfg;
+
+int compare_names2(const void *a, const void *b)
+{
+	const gameinfo *da = (const gameinfo *) a;
+	const gameinfo *db = (const gameinfo *) b;
+
+	return strcasecmp(da->Name, db->Name);
+}
+
+static s32 Download(DOWNLOADS download_number)  {
+
+	ClearScreen();
+	UpdateScreen();
+	//f_chdrive_char(UseSD ? "sd:" : "usb:");
+	f_chdir_char("/apps/Nintendont");
+	int line = 1;
+	int ret;
+	u32 http_status = 0;
+	u8* outbuf = NULL;
+	u32 filesize;
+	char filepath[MAXPATHLEN];
+	//bool dir_argument_exists = strlen(launch_dir);
+	snprintf(filepath, sizeof(filepath), "/apps/Nintendont/%s", filenamez);
+				if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, Downloads[0].text);}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, Downloads[0].text);}
+	UpdateScreen();
+	
+	line++;
+	gprintf("Downloading %s to %s\r\n", Downloads[download_number].url, filepath);
+	ret = net_init();
+	if(ret < 0) {
+		gprintf("Failed to init network\r\n");
+		goto end;
+	}
+	gprintf("Network Initialized\r\n");
+				if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Network Initialized");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Network Initialized");}
+	UpdateScreen();
+	
+	int i;
+	for (i = 0; i <= 10; i++) {
+		ret = http_request(urlz, 0x400000);
+		if (ret) break;
+		if (i == 10) {
+			gprintf("Error making http request\r\n");
+			ret = -1;
+			goto end;
+		}
+	}
+
+	ret = http_get_result(&http_status, &outbuf, &filesize); 
+	if(((int)*outbuf & 0xF0000000) == 0xF0000000) 
+	{
+		ret = -2;
+		goto end;
+	}
+	UpdateScreen();
+	line++;
+		FIL file;
+		if (f_open_char(&file, filepath, FA_WRITE|FA_CREATE_ALWAYS) != FR_OK) {
+			gprintf("File Error\r\n");
+			ret = -3;
+			goto end;
+		} else {
+			UINT wrote;
+			f_write(&file, outbuf, filesize, &wrote);
+			f_close(&file);
+			ret = 1;			
+		}
+	if (ret == 1) {
+										if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Update Complete");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Update Complete");}
+		UpdateScreen();
+		line++;
+		}
+	end:
+	if (ret != 1)
+		{
+			if (which_bg == BG_NONE)
+			PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*(line+1), "Update Error: %i", ret);
+			else if (which_bg == BG_LEGACY)
+			PrintFormat(DEFAULT_SIZE, YELLOW, MENU_POS_X, MENU_POS_Y + 20*(line+1), "Update Error: %i", ret);
+		UpdateScreen();
+		sleep(3);
+		}
+	else
+	{									if (which_bg == BG_NONE)
+	{
+	PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Custom Game Loader Theme Downloaded Successfully");
+	PrintFormat(27, BLACK, MENU_POS_X, MENU_POS_Y + 20*(line+15), "You'll Watch a 3 Seconds Preview Now");
+	PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Custom Game Loader Theme Downloaded Successfully");
+	PrintFormat(27, BLACK, MENU_POS_X, MENU_POS_Y + 20*(line+15), "You'll Watch a 3 Seconds Preview Now");
+	}
+	else if (which_bg == BG_LEGACY)
+	{
+	PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Custom Game Loader Theme Downloaded Successfully");
+	PrintFormat(27, WHITE, MENU_POS_X, MENU_POS_Y + 20*(line+15), "You'll Watch a 3 Seconds Preview Now");
+	PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Custom Game Loader Theme Downloaded Successfully");
+	PrintFormat(27, WHITE, MENU_POS_X, MENU_POS_Y + 20*(line+15), "You'll Watch a 3 Seconds Preview Now");					
+	}	
+	UpdateScreen();
+	sleep(3);
+	//f_chdrive_char(UseSD ? "sd:" : "usb:");
+	f_chdir_char("/apps/Nintendont");
+	f_rename_char("./test.png", filenamez);
+	f_unlink_char( "./NinBackLight.old" );
+	f_unlink_char( "./NinBackDark.old" );
+	f_unlink_char( "./NinBackBars.old" );
+	f_unlink_char( "./NinBackNoBar.old" );
+	f_unlink_char( "./NinBlack.old" );	
+	GRRLIB_FreeTexture(background);
+	background = GRRLIB_LoadTextureFromFile(filenamez);
+	FadeIt();
+	sleep(3);
+	}
+	if (outbuf != NULL) 
+	free(outbuf);
+	net_deinit();
+	BackTheme();
+	UpdateScreen();
+	return (ret-1);
+}	
+
+
+static s32 DownloadAll(DOWNLOADS download_number)  {
+
+	char firstfile[8];
+	char firstfilez[8];
+//	char otherone[8];
+	char filename[MAXPATHLEN];
+	char gamename[MAXPATHLEN];
+	u32 gamecount = 0;
+	u32 i;
+	s32 ScrollX = 0;
+	char buf[0x100];
+	gameinfo gi[MAX_GAMES];
+	DIR pdir;
+	//start:
+	sprintf(filename, "%s:/games", GetRootDevice());
+	if (f_opendir_char(&pdir, filename) != FR_OK)
+	{
+		ClearScreen();
+		gprintf("No FAT device found, or missing %s dir!\n", filename);
+		PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, 232, "No FAT device found, or missing %s dir!", filename );
+		ExitToLoader(1);
+	}
+	memset( gi, 0, sizeof(gameinfo) * MAX_GAMES );
+/*	if( !IsWiiU() )
+	{
+		gi[0].Name = strdup("Boot GC Disc in Drive");
+		gi[0].ID[0] = 'D',gi[0].ID[1] = 'I',gi[0].ID[2] = 'S';
+		gi[0].ID[3] = 'C',gi[0].ID[4] = '0',gi[0].ID[5] = '1';
+		gi[0].Path = strdup("di:di");
+		gamecount++;
+	}*/
+	// TODO: chdir into /games/?
+	FILINFO fInfo;
+	FIL in;
+	while (f_readdir(&pdir, &fInfo) == FR_OK && fInfo.fname[0] != '\0')
+	{
+		if (fInfo.fattrib & AM_DIR)
+		{
+			if (fInfo.fname[0] == '.')	//skip current and previous directories
+				continue;
+
+// NOTE: fInfo.fname[] is UTF-16.
+			const char *filename_utf8 = wchar_to_char(fInfo.fname);
+			int fnlen = snprintf(filename, sizeof(filename), "%s:/games/%s/",
+					     GetRootDevice(), filename_utf8);
+
+			//Test if game.iso exists and add to list
+
+		bool found = false;
+			u32 DiscNumber;
+			for (DiscNumber = 0; DiscNumber < 2; DiscNumber++)
+			{
+				if (DiscNumber)
+					memcpy(&filename[fnlen], "disc2.iso", 10);
+				else
+					memcpy(&filename[fnlen], "game.iso", 9);
+
+				if (f_open_char(&in, filename, FA_READ|FA_OPEN_EXISTING) == FR_OK)
+				{
+					// Read the disc header
+					//gprintf("(%s) ok\n", filename );
+					UINT read;
+					f_read(&in, buf, 0x100, &read);
+					f_close(&in);
+
+					if (read == 0x100 && IsGCGame((u8*)buf))	// Must be GC game
+					{
+						memcpy(gi[gamecount].ID, buf, 6); //ID for EXI
+						gi[gamecount].DiscNumber = DiscNumber;
+
+						// Check if this title is in titles.txt.
+						const char *dbTitle = SearchTitles(gi[gamecount].ID);
+						if (dbTitle)
+						{
+							// Title found.
+							gi[gamecount].Name = (char*)dbTitle;
+							gi[gamecount].NameAlloc = 0;
+						}
+						else
+						{
+							// Title not found.
+							// Use the title from the disc header.
+							strncpy(gamename, buf + 0x20, sizeof(gamename)-1);
+							gamename[sizeof(gamename)-1] = 0;
+							gi[gamecount].Name = strdup(gamename);
+							gi[gamecount].NameAlloc = 1;
+						}
+
+						gi[gamecount].Path = strdup( filename );
+						gamecount++;
+						found = true;
+					}
+				}
+			}
+			if (!found)
+			{
+				memcpy(&filename[fnlen], "sys/boot.bin", 13);
+				if (f_open_char(&in, filename, FA_READ|FA_OPEN_EXISTING) == FR_OK)
+				{
+					//gprintf("(%s) ok\n", filename );
+					UINT read;
+					f_read(&in, buf, 0x100, &read);
+					f_close(&in);
+
+					if (read == 0x100 && IsGCGame((u8*)buf))	// Must be GC game
+					{
+						// Terminate the filename at the game's base directory.
+						filename[fnlen] = 0;
+
+						memcpy(gi[gamecount].ID, buf, 6); //ID for EXI
+						gi[gamecount].DiscNumber = DiscNumber;
+
+						// TODO: Check titles.txt?
+						strncpy(gamename, buf + 0x20, sizeof(gamename)-1);
+						gamename[sizeof(gamename)-1] = 0;
+						gi[gamecount].Name = strdup(gamename);
+						gi[gamecount].NameAlloc = 1;
+
+						gi[gamecount].Path = strdup( filename );
+						gamecount++;
+					}
+				}
+			}
+		}
+		if (gamecount >= MAX_GAMES)	//if array is full
+			break;
+	}
+
+	//if( IsWiiU() )
+		qsort(gi, gamecount, sizeof(gameinfo), compare_names2);
+	/*else if( gamecount > 1 )
+		qsort(&gi[1], gamecount-1, sizeof(gameinfo), compare_names2);*/
+	
+	//f_chdrive_char(UseSD ? "sd:" : "usb:");
+	f_chdir_char("/apps/Nintendont");
+	f_unlink_char( "./NinBackLight.png");
+	f_unlink_char( "./NinBackDark.png");
+	f_unlink_char( "./NinBackBars.png");
+	f_unlink_char( "./NinBackNoBar.png");
+	f_unlink_char( "./NinBlack.png");	
+	
+	ClearScreen();
+	UpdateScreen();
+	
+	int line = 1;
+	int retd;
+	u32 http_status = 0;
+	u8* outbuf = NULL;
+	u32 filesize;
+	char filepath[MAXPATHLEN];
+	//bool dir_argument_exists = strlen(launch_dir);
+	snprintf(filepath, sizeof(filepath), "/apps/Nintendont/%s", filenamez);
+				if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Downloading Custom Game Themes");
+					line++;
+					PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Current Game Themes Will be Deleted");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Downloading Custom Game Themes");
+					line++;
+					PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Current Game Themes Will be Deleted");}
+	UpdateScreen();
+	
+	line++;
+	gprintf("Downloading %s to %s\r\n", Downloads[download_number].url, filepath);
+	retd = net_init();
+	if(retd < 0) {
+		gprintf("Failed to init network\r\n");
+		goto end;
+	}
+	gprintf("Network Initialized\r\n");
+				if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Network Initialized");
+					 PrintFormat(15, BLACK, MENU_POS_X + 225, MENU_POS_Y + 20*21, "Please Wait...");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Network Initialized");
+					 PrintFormat(15, WHITE, MENU_POS_X + 225, MENU_POS_Y + 20*21, "Please Wait...");}
+	UpdateScreen();
+	
+	//f_chdrive_char(UseSD ? "sd:" : "usb:");
+	f_chdir_char("/apps/Nintendont");
+	DeleteCustom();
+/////////////////////////////////////////////////////////////////////////////////////////
+	for( i=0; i <= (gamecount); ++i)
+	{
+	int redraw;
+	char current[3];
+	char total[3];
+	
+	sprintf (current,"%d",(i+1));
+	sprintf (total,"%d",gamecount);
+	sprintf (missing,"%d",miss);
+	memcpy(&(ncfg->GameID), gi[i+ScrollX].ID, 3);
+	memset(GETID3, 0, 8);
+	memcpy(GETID3, &(ncfg->GameID), 3);
+	memset(firstfile, 0, 8);
+	memset(firstfilez, 0, 8);	
+	memcpy(firstfile, gi[0+ScrollX].ID, 3);
+	
+	VIDEO_WaitVSync();
+	redraw=1;
+	if (retry==3) goto out;		
+	if(menumod == 5) {
+	sprintf(firstfilez, "%sX.png", firstfile);
+	sprintf(filenamez, "%sX.png", GETID3);
+	sprintf(urlz, "http://nintendont.gxarena.com/themes/%sX.png", GETID3);
+	}
+	
+	else if(menumod == 4) {
+	sprintf(firstfilez, "%s.png", firstfile);
+	sprintf(filenamez, "%s.png", GETID3);
+	sprintf(urlz, "http://nintendont.gxarena.com/themes/%s.png", GETID3);
+	}	
+		int x;
+		for (x = 0; x <= 10; x++) {
+		retd = http_request(urlz, 0x400000);
+		if (retd) break;
+		if (x == 10) {
+			gprintf("Error making http request\r\n");
+			retd = -1;
+			++miss;
+			sprintf (missing,"%d",miss);
+			if (i == 0)
+			{
+			char SaveFile[10];
+			snprintf(SaveFile, sizeof(SaveFile), "%s", firstfilez);
+			CreateNewFile(SaveFile, 0x0);
+			empty = 1;
+			}
+			}
+		}
+
+	retd = http_get_result(&http_status, &outbuf, &filesize); 
+	if(((int)*outbuf & 0xF0000000) == 0xF0000000) 
+	{
+		retd = -2;
+		goto end;
+	}
+		if (filesize == 0)	
+		del =1;
+		else 
+		del =0;
+		
+		FIL file;
+		if (f_open_char(&file, filepath, FA_WRITE|FA_CREATE_ALWAYS) != FR_OK) {
+			gprintf("File Error\r\n");
+			retd = -3;
+			goto end;
+		} else {
+			UINT wrote;
+			f_write(&file, outbuf, filesize, &wrote);
+			f_close(&file);
+			retd = 1;			
+			}
+			
+			if (i == 0)
+			f_rename_char(firstfilez, "./test.png");
+			
+			if (del == 0)
+			f_rename_char(firstfilez, filenamez);
+			else if (del ==1)
+			f_unlink_char(firstfilez);
+			
+			ClearScreen();
+			if (redraw) {
+			if (which_bg == BG_NONE)
+			{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*(line-2), Downloads[0].text);
+			 PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Network Initialized");
+			 PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*(line-1), "Current Game Themes Will be Deleted");
+			 //PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + (i+10*i), MENU_POS_Y + (20*19), "\xe2\x96\x88\xe2\x96\x88");
+			 PrintFormat(15, BLACK, MENU_POS_X + 225, MENU_POS_Y + 20*20, "Progress %s/%s", current, total);
+			 PrintFormat(15, BLACK, MENU_POS_X + 225, MENU_POS_Y + 20*21, "Missing  %s/%s", missing, total);}
+			else if (which_bg == BG_LEGACY)
+			{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*(line-2), Downloads[0].text);
+			 PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Network Initialized");
+			 PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*(line-1), "Current Game Themes Will be Deleted");
+			 //PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + (i+10*i), MENU_POS_Y + (20*19), "\xe2\x96\x88\xe2\x96\x88");
+			 PrintFormat(15, WHITE, MENU_POS_X + 225, MENU_POS_Y + 20*20, "Progress %s/%s", current, total);
+			 PrintFormat(15, WHITE, MENU_POS_X + 225, MENU_POS_Y + 20*21, "Missing  %s/%s", missing, total);}
+			UpdateScreen();
+			}
+			redraw=0;
+			
+			if (outbuf != NULL) 
+			free(outbuf);
+	
+			if (i == (gamecount-1)) {
+			if (empty ==0)
+			f_rename_char("./test.png", firstfilez);
+			else
+			f_unlink_char("./test.png");
+			goto out;}
+		}	
+	out:
+//////////////////////////////////////////////////////////////////////////////////	
+	line++;
+	if (retd == 1) {
+										if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Update Complete");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Update Complete");}
+		UpdateScreen();
+		line++;
+		sleep(3);
+		}	
+	end:
+	if (retd != 1)
+		{
+			if (retd == -3) 
+			{
+			miss=0;
+			++retry;
+			DownloadAll(0);
+			goto there;}
+			if (which_bg == BG_NONE)
+			{PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*(line+2), "Update Error: %i", retd);
+			//PrintFormat(15, BLACK, MENU_POS_X + 222, MENU_POS_Y + 20*17, "%s Missing Covers", missing);
+			}
+			else if (which_bg == BG_LEGACY)
+			{PrintFormat(DEFAULT_SIZE, YELLOW, MENU_POS_X, MENU_POS_Y + 20*(line+2), "Update Error: %i", retd);
+			//PrintFormat(15, YELLOW, MENU_POS_X + 222, MENU_POS_Y + 20*17, "%s Missing Covers", missing);
+			}
+			/*if (retd == -3) 
+			{
+			if (which_bg == BG_NONE)
+			PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*(line+3), "Please Try Again");
+			else if (which_bg == BG_LEGACY)
+			PrintFormat(DEFAULT_SIZE, YELLOW, MENU_POS_X, MENU_POS_Y + 20*(line+3), "Please Try Again");
+			}*/
+			there:
+		UpdateScreen();
+		sleep(3);
+		}
+	else
+	{	
+	ClearScreen();								
+	if (which_bg == BG_NONE)
+	{
+	PrintFormat(20, BLACK, MENU_POS_X, MENU_POS_Y + 20*14, " All Game Loader Themes Downloaded Successfully");
+	PrintFormat(15, BLACK, MENU_POS_X + 222, MENU_POS_Y + 20*17, "%s Missing Covers", missing);
+	PrintFormat(27, BLACK, MENU_POS_X, MENU_POS_Y + 20*20, "           Have a nice day");
+	}
+	else if (which_bg == BG_LEGACY)
+	{
+	PrintFormat(20, WHITE, MENU_POS_X, MENU_POS_Y + 20*14, " All Game Loader Themes Downloaded Successfully");
+	PrintFormat(15, WHITE, MENU_POS_X + 222, MENU_POS_Y + 20*17, "%s Missing Covers", missing);
+	PrintFormat(27, WHITE, MENU_POS_X, MENU_POS_Y + 20*20, "           Have a nice day");				
+	}	
+	UpdateScreen();
+	sleep(3);
+	}
+	net_deinit();
+	BackTheme();
+	UpdateScreen();
+	return (retd-1);
+}
+
+void DownloadGame(void)
+{ 
+//Create a list of games
+	char filename[MAXPATHLEN];
+	char gamename[MAXPATHLEN];
+	u32 gamecount = 0;
+	char buf[0x100];
+	gameinfo gi[MAX_GAMES];
+	DIR pdir;
+	//start:
+	sprintf(filename, "%s:/games", GetRootDevice());
+	if (f_opendir_char(&pdir, filename) != FR_OK)
+	{
+		ClearScreen();
+		gprintf("No FAT device found, or missing %s dir!\n", filename);
+		PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, 232, "No FAT device found, or missing %s dir!", filename );
+		ExitToLoader(1);
+	}
+	memset( gi, 0, sizeof(gameinfo) * MAX_GAMES );
+/*	if( !IsWiiU() )
+	{
+		gi[0].Name = strdup("Boot GC Disc in Drive");
+		gi[0].ID[0] = 'D',gi[0].ID[1] = 'I',gi[0].ID[2] = 'S';
+		gi[0].ID[3] = 'C',gi[0].ID[4] = '0',gi[0].ID[5] = '1';
+		gi[0].Path = strdup("di:di");
+		gamecount++;
+	}*/
+	// TODO: chdir into /games/?
+	FILINFO fInfo;
+	FIL in;
+	while (f_readdir(&pdir, &fInfo) == FR_OK && fInfo.fname[0] != '\0')
+	{
+		if (fInfo.fattrib & AM_DIR)
+		{
+			if (fInfo.fname[0] == '.')	//skip current and previous directories
+				continue;
+
+// NOTE: fInfo.fname[] is UTF-16.
+			const char *filename_utf8 = wchar_to_char(fInfo.fname);
+			int fnlen = snprintf(filename, sizeof(filename), "%s:/games/%s/",
+					     GetRootDevice(), filename_utf8);
+
+			//Test if game.iso exists and add to list
+
+		bool found = false;
+			u32 DiscNumber;
+			for (DiscNumber = 0; DiscNumber < 2; DiscNumber++)
+			{
+				if (DiscNumber)
+					memcpy(&filename[fnlen], "disc2.iso", 10);
+				else
+					memcpy(&filename[fnlen], "game.iso", 9);
+
+				if (f_open_char(&in, filename, FA_READ|FA_OPEN_EXISTING) == FR_OK)
+				{
+					// Read the disc header
+					//gprintf("(%s) ok\n", filename );
+					UINT read;
+					f_read(&in, buf, 0x100, &read);
+					f_close(&in);
+
+					if (read == 0x100 && IsGCGame((u8*)buf))	// Must be GC game
+					{
+						memcpy(gi[gamecount].ID, buf, 6); //ID for EXI
+						gi[gamecount].DiscNumber = DiscNumber;
+
+						// Check if this title is in titles.txt.
+						const char *dbTitle = SearchTitles(gi[gamecount].ID);
+						if (dbTitle)
+						{
+							// Title found.
+							gi[gamecount].Name = (char*)dbTitle;
+							gi[gamecount].NameAlloc = 0;
+						}
+						else
+						{
+							// Title not found.
+							// Use the title from the disc header.
+							strncpy(gamename, buf + 0x20, sizeof(gamename)-1);
+							gamename[sizeof(gamename)-1] = 0;
+							gi[gamecount].Name = strdup(gamename);
+							gi[gamecount].NameAlloc = 1;
+						}
+
+						gi[gamecount].Path = strdup( filename );
+						gamecount++;
+						found = true;
+					}
+				}
+			}
+			if (!found)
+			{
+				memcpy(&filename[fnlen], "sys/boot.bin", 13);
+				if (f_open_char(&in, filename, FA_READ|FA_OPEN_EXISTING) == FR_OK)
+				{
+					//gprintf("(%s) ok\n", filename );
+					UINT read;
+					f_read(&in, buf, 0x100, &read);
+					f_close(&in);
+
+					if (read == 0x100 && IsGCGame((u8*)buf))	// Must be GC game
+					{
+						// Terminate the filename at the game's base directory.
+						filename[fnlen] = 0;
+
+						memcpy(gi[gamecount].ID, buf, 6); //ID for EXI
+						gi[gamecount].DiscNumber = DiscNumber;
+
+						// TODO: Check titles.txt?
+						strncpy(gamename, buf + 0x20, sizeof(gamename)-1);
+						gamename[sizeof(gamename)-1] = 0;
+						gi[gamecount].Name = strdup(gamename);
+						gi[gamecount].NameAlloc = 1;
+
+						gi[gamecount].Path = strdup( filename );
+						gamecount++;
+					}
+				}
+			}
+		}
+		if (gamecount >= MAX_GAMES)	//if array is full
+			break;
+	}
+
+	//if( IsWiiU() )
+		qsort(gi, gamecount, sizeof(gameinfo), compare_names2);
+	/*else if( gamecount > 1 )
+		qsort(&gi[1], gamecount-1, sizeof(gameinfo), compare_names2);*/
+
+	u32 i;
+	s32 PosX = 0;
+	s32 ScrollX = 0;
+	u32 MenuMode = 0;
+
+	u32 ListMax = gamecount;
+	if( ListMax > 15 )
+		ListMax = 15;
+	FadeIt();
+//	set default game to game that currently set in configuration
+	for (i = 0; i < gamecount; ++i)
+	{
+		if (strcasecmp(strchr(gi[i].Path,':')+1, ncfg->GamePath) == 0)
+		{
+			if( i >= ListMax )
+			{
+				PosX	= ListMax - 1;
+				ScrollX = i - ListMax + 1;
+			} else {
+				PosX = i;
+			}
+			break;
+		}
+	}
+	UpdateScreen();
+	u32 UpHeld = 0, DownHeld = 0;
+	while(1)
+	{
+		VIDEO_WaitVSync();
+		FPAD_Update();
+		if( FPAD_Start(1) )
+		{
+			ClearScreen();
+					if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, 212, 232, "Returning to loader..." );	}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, 212, 232, "Returning to loader..." );	}
+			ExitToLoader(0);
+		}
+
+		if( FPAD_Cancel(0) )
+		{
+			return;
+			redraw = 1;
+		}
+
+	//	gprintf("\rS:%u P:%u G:%u M:%u    ", ScrollX, PosX, gamecount, ListMax );
+
+		if( MenuMode == 0 )		//game select menu
+		{
+			if(FPAD_X(0)) {				
+				UpdateNintendont();
+				redraw = 1;
+			}
+			if(FPAD_Y(0)) {
+				Credits();
+				redraw = 1;
+			}			
+			if( FPAD_Down(1) )
+			{
+				if(DownHeld == 0 || DownHeld > 10)
+				{
+					if (which_bg == BG_NONE)
+					{
+					PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X+51*6-8, MENU_POS_Y + 20*6 + PosX * 20, " " );
+					}
+					else if (which_bg == BG_LEGACY)
+					{
+					PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X+51*6-8, MENU_POS_Y + 20*6 + PosX * 20, " " );
+					}					
+					if( PosX + 1 >= ListMax )
+					{
+						if( PosX + 1 + ScrollX < gamecount)
+							ScrollX++;
+						else {
+							PosX	= 0;
+							ScrollX = 0;
+						}
+					} else {
+						PosX++;
+					}
+					redraw=1;
+					}
+				DownHeld++;
+			}
+			else
+				DownHeld = 0;
+			if( FPAD_Right(0) )
+			{
+					if (which_bg == BG_NONE)
+					{
+					PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X+51*6-8, MENU_POS_Y + 20*6 + PosX * 20, " " );
+					}
+					else if (which_bg == BG_LEGACY)
+					{
+					PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X+51*6-8, MENU_POS_Y + 20*6 + PosX * 20, " " );
+					}	
+				if( PosX == ListMax - 1 )
+				{
+					if( PosX + ListMax + ScrollX < gamecount)
+						ScrollX = ScrollX + ListMax;
+					else
+					if( PosX + ScrollX != gamecount -1)
+						ScrollX = gamecount - ListMax;
+					else {
+						PosX	= 0;
+						ScrollX = 0;
+					}
+				} else {
+					PosX = ListMax - 1;
+				}
+				redraw=1;
+			}
+			if( FPAD_Up(1) )
+			{
+				if(UpHeld == 0 || UpHeld > 10)
+				{
+					if (which_bg == BG_NONE)
+					{
+					PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X+51*6-8, MENU_POS_Y + 20*6 + PosX * 20, " " );
+					}
+					else if (which_bg == BG_LEGACY)
+					{
+					PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X+51*6-8, MENU_POS_Y + 20*6 + PosX * 20, " " );
+					}	
+					if( PosX <= 0 )
+					{
+						if( ScrollX > 0 )
+							ScrollX--;
+						else {
+							PosX	= ListMax - 1;
+							ScrollX = gamecount - ListMax;
+						}
+					} else {
+						PosX--;
+					}
+					redraw=1;
+				}
+				UpHeld++;
+			}
+			else
+				UpHeld = 0;
+			if( FPAD_Left(0) )
+			{
+					if (which_bg == BG_NONE)
+					{
+					PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X+51*6-8, MENU_POS_Y + 20*6 + PosX * 20, " " );
+					}
+					else if (which_bg == BG_LEGACY)
+					{
+					PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X+51*6-8, MENU_POS_Y + 20*6 + PosX * 20, " " );
+					}	
+				if( PosX == 0 )
+				{
+					if( ScrollX - (s32)ListMax >= 0 )
+						ScrollX = ScrollX - ListMax;
+					else
+					if( ScrollX != 0 )
+						ScrollX = 0;
+					else {
+						ScrollX = gamecount - ListMax;
+					}
+				} else {
+					PosX = 0;
+				}
+				redraw=1;
+			}
+
+			if( FPAD_OK(0) )
+			{
+			break;
+			}
+
+			if( redraw )
+			{
+				PrintInfo();
+					if (which_bg == BG_NONE)
+					{
+				PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y, "  Home: Exit");
+				if (menumod == 3)
+				PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*1, "  A   : Delete");
+				else 
+				PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*1, "  A   : Download");
+				PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*2, "  B   : Game List");
+				PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*2, "Custom Game Themes Manager");
+				PrintFormat(15, BLACK, MENU_POS_X + 235, MENU_POS_Y + 20*21, "Y/2: Credits");
+					}
+					else if (which_bg == BG_LEGACY)
+					{
+				PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y, "  Home: Exit");
+				if (menumod == 3)
+				PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y + 20*1, "  A   : Delete");
+				else 
+				PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y + 20*1, "  A   : Download");
+				PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y + 20*2, "  B   : Game List");
+				PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*2, "Custom Game Themes Manager");
+				PrintFormat(15, WHITE, MENU_POS_X + 235, MENU_POS_Y + 20*21, "Y/2: Credits");
+					}					
+
+				for( i=0; i < ListMax; ++i )
+					if (which_bg == BG_NONE)
+					{
+			PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*5 + i * 20, "%s[%.6s] %50.50s", i == PosX ? ARROW_RIGHT : " ", gi[i+ScrollX].ID, gi[i+ScrollX].Name);
+					}
+					else if (which_bg == BG_LEGACY)
+					{
+			PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*5 + i * 20, "%s[%.6s] %50.50s", i == PosX ? ARROW_RIGHT : " ", gi[i+ScrollX].ID, gi[i+ScrollX].Name);
+					}	
+				GRRLIB_Render();
+				Screenshot();
+				ClearScreen();
+				redraw = 0;
+			}
+
+		}
+	}
+	u32 SelectedGame = PosX + ScrollX;
+	char* StartChar = gi[SelectedGame].Path + 3;
+	if (StartChar[0] == ':')
+		StartChar++;
+	memcpy(&(ncfg->GameID), gi[SelectedGame].ID, 3);
+	memset(GETID3, 0, 8);
+	char fileid4[8];
+	memset(fileid4, 0, 8);	
+	memcpy(GETID3, &(ncfg->GameID), 3);
+	//f_chdrive_char(UseSD ? "sd:" : "usb:");
+	f_chdir_char("/apps/Nintendont");
+	
+	if (menumod == 3) {
+	BackTheme();
+	sprintf(filenamez, "%s.png", GETID3);
+	sprintf(fileid4, "%sX.png", GETID3);
+	f_unlink_char(filenamez);
+	f_unlink_char(fileid4);
+	if (which_bg == BG_NONE)
+	{PrintFormat(30, BLACK, MENU_POS_X, MENU_POS_Y + 20*10, "Game Theme Successfully Deleted");}
+	else if (which_bg == BG_LEGACY)
+	{PrintFormat(30, WHITE, MENU_POS_X, MENU_POS_Y + 20*10, "Game Theme Successfully Deleted");}
+	UpdateScreen();
+	sleep (2);
+	redraw = 1;
+	return;
+	}
+	
+	else if(menumod == 2) {
+	sprintf(filenamez, "%sX.png", GETID3);
+	sprintf(fileid4, "%sX.png", GETID3);
+	sprintf(urlz, "http://nintendont.gxarena.com/themes/%sX.png", GETID3);
+	f_unlink_char(filenamez);
+	f_unlink_char(fileid4);
+	f_rename_char( "./NinBackLight.png", "./NinBackLight.old");
+	f_rename_char( "./NinBackDark.png", "./NinBackDark.old");
+	f_rename_char( "./NinBackBars.png", "./NinBackBars.old");
+	f_rename_char( "./NinBackNoBar.png", "./NinBackNoBar.old");
+	f_rename_char( "./NinBlack.png", "./NinBlack.old");
+	Download(0);
+	}
+	
+	else if(menumod == 1) {
+	sprintf(filenamez, "%s.png", GETID3);
+	sprintf(fileid4, "%sX.png", GETID3);
+	sprintf(urlz, "http://nintendont.gxarena.com/themes/%s.png", GETID3);
+	f_unlink_char(filenamez);
+	f_unlink_char(fileid4);
+	f_rename_char( "./NinBackLight.png", "./NinBackLight.old");
+	f_rename_char( "./NinBackDark.png", "./NinBackDark.old");
+	f_rename_char( "./NinBackBars.png", "./NinBackBars.old");
+	f_rename_char( "./NinBackNoBar.png", "./NinBackNoBar.old");
+	f_rename_char( "./NinBlack.png", "./NinBlack.old");
+	Download(0);
+	}
+	for (i = 0; i < gamecount; ++i)
+	{
+		if (gi[i].NameAlloc)
+			free(gi[i].Name);
+		free(gi[i].Path);
+	}
+	redraw = 1;
+	return;
+}
+
+void GDMenu(void) {
+	selected = 0;
+	u64 delay = ticks_to_millisecs(gettime()) + 500;
+	while(true) {
+		ClearScreen();
+		if (which_bg == BG_NONE)
+					{		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y, "  Home: Exit");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*1, "  A   : Select");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*2, "  B   : Back");	
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*2, "Custom Game Themes Menu");	
+		PrintFormat(15, BLACK, MENU_POS_X + 235, MENU_POS_Y + 20*21, "Y/2: Credits");	
+		PrintInfo();
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*4, "Manually Download a Game Theme  (Without Progress Bar)");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*5, "Download All Custom Game Themes (Without Progress Bar)");		
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*6, "Manually Download a Game Theme  (With Progress Bar)");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*7, "Download All Custom Game Themes (With Progress Bar)");		
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*8, "Manually Delete Individual Custom Game Theme");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*9, "Automatically Delete All Custom Game Themes!");		
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*10, "Return to Update Menu");	
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 35, MENU_POS_Y + 20*(4+selected), ARROW_RIGHT);}
+					else if (which_bg == BG_LEGACY)
+					{		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y, "  Home: Exit");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y + 20*1, "  A   : Select");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y + 20*2, "  B   : Back");	
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*2, "Custom Game Themes Menu");		
+		PrintFormat(15, WHITE, MENU_POS_X + 235, MENU_POS_Y + 20*21, "Y/2: Credits");	
+		PrintInfo();
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*4, "Manually Download a Game Theme  (Without Progress Bar)");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*5, "Download All Custom Game Themes (Without Progress Bar)");		
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*6, "Manually Download a Game Theme  (With Progress Bar)");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*7, "Download All Custom Game Themes (With Progress Bar)");		
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*8, "Manually Delete Individual Custom Game Theme");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*9, "Automatically Delete All Custom Game Themes!");			
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*10, "Return to Update Menu");	
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 35, MENU_POS_Y + 20*(4+selected), ARROW_RIGHT);}
+		//////////
+		if (f_chdir_char("/apps/Nintendont/Preview/game") == FR_OK){
+		
+			GRRLIB_FreeTexture(preview);
+			if (selected == 0)
+			preview = GRRLIB_LoadTextureFromFile("00.png");
+			else if (selected == 1)
+			preview = GRRLIB_LoadTextureFromFile("01.png");
+			else if (selected == 2)
+			preview = GRRLIB_LoadTextureFromFile("02.png");
+			else if (selected == 3)
+			preview = GRRLIB_LoadTextureFromFile("03.png");
+			else if (selected == 4)
+			preview = GRRLIB_LoadTextureFromFile("04.png");
+			else if (selected == 5)
+			preview = GRRLIB_LoadTextureFromFile("05.png");
+			else if (selected == 6)
+			preview = GRRLIB_LoadTextureFromFile("06.png");	
+			GRRLIB_DrawImg(220, 282, preview, 0, 1, 1, 0xFFFFFFFF);
+		}
+		//////////
+		GRRLIB_Render();
+		FPAD_Update();
+		if (delay > ticks_to_millisecs(gettime())) continue;
+		if (FPAD_Start(1)) {
+			ClearScreen();
+					if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, 212, 232, "Returning to loader...");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, 212, 232, "Returning to loader...");}
+			ExitToLoader(0);
+		}
+		if (FPAD_OK(1)) {
+			//f_chdrive_char(UseSD ? "sd:" : "usb:");
+			f_chdir_char("/apps/Nintendont");
+			if (selected == (DOWNLOAD_01))
+			{menumod = 1;
+			DownloadGame();}
+			if (selected == (DOWNLOAD_02))
+			{menumod = 4;
+			DownloadAll(0);}
+			if (selected == (DOWNLOAD_03))
+			{menumod = 2;
+			DownloadGame();}
+			if (selected == (DOWNLOAD_04))
+			{menumod = 5;
+			DownloadAll(0);}
+			if (selected == (DOWNLOAD_05))
+			{menumod = 3;
+			DownloadGame();}			
+			if (selected == (DOWNLOAD_06)) 
+			{
+			DeleteCustom();
+			ClearScreen();
+			BackTheme();
+			if (which_bg == BG_NONE)
+			{PrintFormat(30, BLACK, MENU_POS_X, MENU_POS_Y + 20*10, "Game Themes Successfully Deleted");}
+			else if (which_bg == BG_LEGACY)
+			{PrintFormat(30, WHITE, MENU_POS_X, MENU_POS_Y + 20*10, "Game Themes Successfully Deleted");}
+			UpdateScreen();
+			sleep (2);
+			redraw = 1;
+			return;}
+			if (selected == (DOWNLOAD_07)) 
+			break;
+			else
+				break;}
+		if (FPAD_Down(1)) {
+			delay = ticks_to_millisecs(gettime()) + 150;
+			selected++;
+			if (selected > 6) selected = 0;
+		}
+		if (FPAD_Up(1)) {
+			delay = ticks_to_millisecs(gettime()) + 150;
+			selected--;
+			if (selected < 0) selected = 6;
+		}
+		if(FPAD_Y(0)) {
+				Credits();
+		}				
+		if (FPAD_Cancel(1)) {
+			break;
+		}
+	}
+	ClearScreen();
+	UpdateNintendont();
+}
